keyconfig_data = \
[("Screen",
  {"space_type": 'EMPTY', "region_type": 'WINDOW'},
  {"items":
   [("screen.animation_step", {"type": 'TIMER0', "value": 'ANY', "any": True}, None),
    ("screen.region_blend", {"type": 'TIMERREGION', "value": 'ANY', "any": True}, None),
    ("screen.screen_full_area", {"type": 'SPACE', "value": 'PRESS', "ctrl": True}, None),
    ("screen.screen_full_area",
     {"type": 'SPACE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("use_hide_panels", True),
       ],
      },
     ),
    ("screen.space_context_cycle",
     {"type": 'TAB', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("direction", 'NEXT'),
       ],
      },
     ),
    ("screen.space_context_cycle",
     {"type": 'TAB', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("direction", 'PREV'),
       ],
      },
     ),
    ("screen.workspace_cycle",
     {"type": 'PAGE_DOWN', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("direction", 'NEXT'),
       ],
      },
     ),
    ("screen.workspace_cycle",
     {"type": 'PAGE_UP', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("direction", 'PREV'),
       ],
      },
     ),
    ("screen.region_quadview", {"type": 'Q', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ("screen.repeat_last", {"type": 'R', "value": 'PRESS', "shift": True}, None),
    ("file.execute", {"type": 'RET', "value": 'PRESS'}, None),
    ("file.execute", {"type": 'NUMPAD_ENTER', "value": 'PRESS'}, None),
    ("file.cancel", {"type": 'ESC', "value": 'PRESS'}, None),
    ("ed.undo", {"type": 'Z', "value": 'PRESS', "ctrl": True}, None),
    ("ed.redo", {"type": 'Z', "value": 'PRESS', "shift": True, "ctrl": True}, None),
    ("render.render",
     {"type": 'F12', "value": 'PRESS'},
     {"properties":
      [("use_viewport", True),
       ],
      },
     ),
    ("render.render",
     {"type": 'F12', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("animation", True),
       ("use_viewport", True),
       ],
      },
     ),
    ("render.view_cancel", {"type": 'ESC', "value": 'PRESS'}, None),
    ("render.view_show", {"type": 'F11', "value": 'PRESS'}, None),
    ("render.play_rendered_anim", {"type": 'F11', "value": 'PRESS', "ctrl": True}, None),
    ],
   },
  ),
 ("Object Mode",
  {"space_type": 'EMPTY', "region_type": 'WINDOW'},
  {"items":
   [("wm.call_menu_pie",
     {"type": 'O', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_proportional_editing_falloff_pie'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'O', "value": 'PRESS'},
     {"properties":
      [("data_path", 'tool_settings.use_proportional_edit_objects'),
       ],
      },
     ),
    ("object.select_all",
     {"type": 'A', "value": 'PRESS'},
     {"properties":
      [("action", 'SELECT'),
       ],
      },
     ),
    ("object.select_all",
     {"type": 'A', "value": 'PRESS', "alt": True},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("object.select_all",
     {"type": 'I', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("action", 'INVERT'),
       ],
      },
     ),
    ("object.select_all",
     {"type": 'A', "value": 'DOUBLE_CLICK'},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("object.select_more", {"type": 'NUMPAD_PLUS', "value": 'PRESS', "ctrl": True}, None),
    ("object.select_less", {"type": 'NUMPAD_MINUS', "value": 'PRESS', "ctrl": True}, None),
    ("object.select_linked", {"type": 'L', "value": 'PRESS', "shift": True}, None),
    ("object.select_grouped", {"type": 'G', "value": 'PRESS', "shift": True}, None),
    ("object.select_hierarchy",
     {"type": 'LEFT_BRACKET', "value": 'PRESS'},
     {"properties":
      [("direction", 'PARENT'),
       ("extend", False),
       ],
      },
     ),
    ("object.select_hierarchy",
     {"type": 'LEFT_BRACKET', "value": 'PRESS', "shift": True},
     {"properties":
      [("direction", 'PARENT'),
       ("extend", True),
       ],
      },
     ),
    ("object.select_hierarchy",
     {"type": 'RIGHT_BRACKET', "value": 'PRESS'},
     {"properties":
      [("direction", 'CHILD'),
       ("extend", False),
       ],
      },
     ),
    ("object.select_hierarchy",
     {"type": 'RIGHT_BRACKET', "value": 'PRESS', "shift": True},
     {"properties":
      [("direction", 'CHILD'),
       ("extend", True),
       ],
      },
     ),
    ("object.parent_set", {"type": 'P', "value": 'PRESS', "ctrl": True}, None),
    ("object.parent_clear", {"type": 'P', "value": 'PRESS', "alt": True}, None),
    ("object.location_clear",
     {"type": 'G', "value": 'PRESS', "alt": True},
     {"properties":
      [("clear_delta", False),
       ],
      },
     ),
    ("object.rotation_clear",
     {"type": 'R', "value": 'PRESS', "alt": True},
     {"properties":
      [("clear_delta", False),
       ],
      },
     ),
    ("object.scale_clear",
     {"type": 'S', "value": 'PRESS', "alt": True},
     {"properties":
      [("clear_delta", False),
       ],
      },
     ),
    ("object.delete",
     {"type": 'X', "value": 'PRESS'},
     {"properties":
      [("use_global", False),
       ],
      },
     ),
    ("object.delete",
     {"type": 'X', "value": 'PRESS', "shift": True},
     {"properties":
      [("use_global", True),
       ],
      },
     ),
    ("object.delete",
     {"type": 'DEL', "value": 'PRESS'},
     {"properties":
      [("use_global", False),
       ("confirm", False),
       ],
      },
     ),
    ("object.delete",
     {"type": 'DEL', "value": 'PRESS', "shift": True},
     {"properties":
      [("use_global", True),
       ("confirm", False),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'A', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_add'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'A', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_object_apply'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'L', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_make_links'),
       ],
      },
     ),
    ("object.duplicate_move", {"type": 'D', "value": 'PRESS', "shift": True}, None),
    ("object.duplicate_move_linked", {"type": 'D', "value": 'PRESS', "alt": True}, None),
    ("object.join", {"type": 'J', "value": 'PRESS', "ctrl": True}, None),
    ("anim.keyframe_insert_menu", {"type": 'I', "value": 'PRESS'}, None),
    ("anim.keyframe_delete_v3d", {"type": 'I', "value": 'PRESS', "alt": True}, None),
    ("anim.keying_set_active_set", {"type": 'I', "value": 'PRESS', "shift": True, "ctrl": True, "alt": True}, None),
    ("collection.create", {"type": 'G', "value": 'PRESS', "ctrl": True}, None),
    ("collection.objects_remove", {"type": 'G', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ("collection.objects_remove_all", {"type": 'G', "value": 'PRESS', "shift": True, "ctrl": True, "alt": True}, None),
    ("collection.objects_add_active", {"type": 'G', "value": 'PRESS', "shift": True, "ctrl": True}, None),
    ("collection.objects_remove_active", {"type": 'G', "value": 'PRESS', "shift": True, "alt": True}, None),
    ("wm.call_menu",
     {"type": 'RIGHTMOUSE', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_object_specials'),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'ZERO', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 0),
       ("relative", False),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'ONE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 1),
       ("relative", False),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'TWO', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 2),
       ("relative", False),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'THREE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 3),
       ("relative", False),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'FOUR', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 4),
       ("relative", False),
       ],
      },
     ),
    ("object.subdivision_set",
     {"type": 'FIVE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("level", 5),
       ("relative", False),
       ],
      },
     ),
    ("object.move_to_collection", {"type": 'M', "value": 'PRESS'}, None),
    ("object.link_to_collection", {"type": 'M', "value": 'PRESS', "shift": True}, None),
    ("object.hide_view_clear", {"type": 'H', "value": 'PRESS', "alt": True}, None),
    ("object.hide_view_set",
     {"type": 'H', "value": 'PRESS'},
     {"properties":
      [("unselected", False),
       ],
      },
     ),
    ("object.hide_view_set",
     {"type": 'H', "value": 'PRESS', "shift": True},
     {"properties":
      [("unselected", True),
       ],
      },
     ),
    ("object.hide_collection",
     {"type": 'H', "value": 'PRESS', "ctrl": True},
     {    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'TWO', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 2),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'THREE', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 3),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'FOUR', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 4),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'FIVE', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 5),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'SIX', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 6),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'SEVEN', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 7),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'EIGHT', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 8),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'NINE', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 9),
       ],
    "active":False,
      },
     ),
    ("object.hide_collection",
     {"type": 'ZERO', "value": 'PRESS', "any": True},
     {"properties":
      [("collection_index", 10),
       ],
    "active":False,
      },
     ),
    ("object.origin_set",
     {"type": 'Q', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'ORIGIN_CENTER_OF_MASS'),
       ],
      },
     ),
    ("object.origin_set",
     {"type": 'NONE', "value": 'PRESS'},
     {"properties":
      [("type", 'ORIGIN_CURSOR'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'F2', "value": 'PRESS'},
     {"properties":
      [("name", 'mesh.MyPie'),
       ],
      },
     ),
    ("object.origin_set",
     {"type": 'Q', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'ORIGIN_CURSOR'),
       ],
      },
     ),
    ("object.my_vertex_select", {"type": 'ONE', "value": 'PRESS'}, None),
    ("object.my_edge_select", {"type": 'TWO', "value": 'PRESS'}, None),
    ("object.my_face_select", {"type": 'THREE', "value": 'PRESS'}, None),
    ("object.hide_view_set",
     {"type": 'H', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("unselected", False),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'Q', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Box'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'W', "value": 'PRESS'},
     {"properties":
      [("name", 'Move'),
       ("cycle", False),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'E', "value": 'PRESS'},
     {"properties":
      [("name", 'Rotate'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'R', "value": 'PRESS'},
     {"properties":
      [("name", 'Scale'),
       ],
      },
     ),
    ],
   },
  ),
 ("Mesh",
  {"space_type": 'EMPTY', "region_type": 'WINDOW'},
  {"items":
   [("mesh.loopcut_slide",
     {"type": 'R', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("TRANSFORM_OT_edge_slide",
        [("release_confirm", False),
         ],
        ),
       ],
      },
     ),
    ("mesh.offset_edge_loops_slide",
     {"type": 'R', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("TRANSFORM_OT_edge_slide",
        [("release_confirm", False),
         ],
        ),
       ],
      },
     ),
    ("mesh.inset", {"type": 'I', "value": 'PRESS'}, None),
    ("mesh.bevel",
     {"type": 'B', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("vertex_only", False),
       ],
      },
     ),
    ("mesh.bevel",
     {"type": 'B', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("vertex_only", True),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'ONE', "value": 'PRESS'},
     {"properties":
      [("type", 'VERT'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'TWO', "value": 'PRESS'},
     {"properties":
      [("type", 'EDGE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'THREE', "value": 'PRESS'},
     {"properties":
      [("type", 'FACE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'ONE', "value": 'PRESS', "shift": True},
     {"properties":
      [("use_extend", True),
       ("type", 'VERT'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'TWO', "value": 'PRESS', "shift": True},
     {"properties":
      [("use_extend", True),
       ("type", 'EDGE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'THREE', "value": 'PRESS', "shift": True},
     {"properties":
      [("use_extend", True),
       ("type", 'FACE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'ONE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("use_expand", True),
       ("type", 'VERT'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'TWO', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("use_expand", True),
       ("type", 'EDGE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'THREE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("use_expand", True),
       ("type", 'FACE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'ONE', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("use_extend", True),
       ("use_expand", True),
       ("type", 'VERT'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'TWO', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("use_extend", True),
       ("use_expand", True),
       ("type", 'EDGE'),
       ],
      },
     ),
    ("mesh.select_mode",
     {"type": 'THREE', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("use_extend", True),
       ("use_expand", True),
       ("type", 'FACE'),
       ],
      },
     ),
    ("mesh.loop_select",
     {"type": 'LEFTMOUSE', "value": 'DOUBLE_CLICK'},
     {"properties":
      [("extend", False),
       ("deselect", False),
       ("toggle", False),
       ],
      },
     ),
    ("mesh.loop_select",
     {"type": 'LEFTMOUSE', "value": 'DOUBLE_CLICK', "shift": True},
     {"properties":
      [("extend", True),
       ("deselect", False),
       ("toggle", False),
       ],
      },
     ),
    ("mesh.loop_select",
     {"type": 'LEFTMOUSE', "value": 'DOUBLE_CLICK', "ctrl": True},
     {"properties":
      [("extend", False),
       ("deselect", True),
       ("toggle", False),
       ],
      },
     ),
    ("mesh.loop_select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "alt": True},
     {"properties":
      [("extend", False),
       ("deselect", False),
       ("toggle", False),
       ],
    "active":False,
      },
     ),
    ("mesh.loop_select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "alt": True},
     {"properties":
      [("extend", False),
       ("deselect", False),
       ("toggle", True),
       ],
      },
     ),
    ("mesh.edgering_select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "ctrl": True, "alt": True},
     {"properties":
      [("extend", False),
       ("deselect", False),
       ("toggle", False),
       ],
      },
     ),
    ("mesh.edgering_select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "ctrl": True, "alt": True},
     {"properties":
      [("extend", False),
       ("deselect", False),
       ("toggle", True),
       ],
      },
     ),
    ("mesh.shortest_path_pick",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "ctrl": True},
     {"properties":
      [("use_fill", False),
       ],
      },
     ),
    ("mesh.shortest_path_pick",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "ctrl": True},
     {"properties":
      [("use_fill", True),
       ],
      },
     ),
    ("mesh.select_all",
     {"type": 'A', "value": 'PRESS'},
     {"properties":
      [("action", 'SELECT'),
       ],
      },
     ),
    ("mesh.select_all",
     {"type": 'A', "value": 'PRESS', "alt": True},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("mesh.select_all",
     {"type": 'I', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("action", 'INVERT'),
       ],
      },
     ),
    ("mesh.select_all",
     {"type": 'A', "value": 'DOUBLE_CLICK'},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("mesh.select_more", {"type": 'NUMPAD_PLUS', "value": 'PRESS', "ctrl": True}, None),
    ("mesh.select_less", {"type": 'NUMPAD_MINUS', "value": 'PRESS', "ctrl": True}, None),
    ("mesh.select_next_item", {"type": 'NUMPAD_PLUS', "value": 'PRESS', "shift": True, "ctrl": True}, None),
    ("mesh.select_prev_item", {"type": 'NUMPAD_MINUS', "value": 'PRESS', "shift": True, "ctrl": True}, None),
    ("mesh.select_linked", {"type": 'L', "value": 'PRESS', "ctrl": True}, None),
    ("mesh.select_linked_pick",
     {"type": 'L', "value": 'PRESS'},
     {"properties":
      [("deselect", False),
       ],
      },
     ),
    ("mesh.select_linked_pick",
     {"type": 'L', "value": 'PRESS', "shift": True},
     {"properties":
      [("deselect", True),
       ],
      },
     ),
    ("mesh.select_mirror", {"type": 'M', "value": 'PRESS', "shift": True, "ctrl": True}, None),
    ("wm.call_menu",
     {"type": 'G', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_select_similar'),
       ],
      },
     ),
    ("mesh.hide",
     {"type": 'H', "value": 'PRESS'},
     {"properties":
      [("unselected", False),
       ],
      },
     ),
    ("mesh.hide",
     {"type": 'H', "value": 'PRESS', "shift": True},
     {"properties":
      [("unselected", True),
       ],
      },
     ),
    ("mesh.reveal", {"type": 'H', "value": 'PRESS', "alt": True}, None),
    ("mesh.normals_make_consistent",
     {"type": 'N', "value": 'PRESS', "shift": True},
     {"properties":
      [("inside", False),
       ],
      },
     ),
    ("mesh.normals_make_consistent",
     {"type": 'N', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("inside", True),
       ],
      },
     ),
    ("view3d.edit_mesh_extrude_move_normal", {"type": 'E', "value": 'PRESS', "shift": True}, None),
    ("wm.call_menu",
     {"type": 'E', "value": 'PRESS', "alt": True},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_extrude'),
       ],
      },
     ),
    ("transform.edge_crease", {"type": 'E', "value": 'PRESS', "shift": True}, None),
    ("mesh.fill", {"type": 'F', "value": 'PRESS', "alt": True}, None),
    ("mesh.quads_convert_to_tris",
     {"type": 'T', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("quad_method", 'BEAUTY'),
       ("ngon_method", 'BEAUTY'),
       ],
      },
     ),
    ("mesh.quads_convert_to_tris",
     {"type": 'T', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("quad_method", 'FIXED'),
       ("ngon_method", 'CLIP'),
       ],
      },
     ),
    ("mesh.tris_convert_to_quads", {"type": 'J', "value": 'PRESS', "alt": True}, None),
    ("mesh.rip_move",
     {"type": 'V', "value": 'PRESS'},
     {"properties":
      [("MESH_OT_rip",
        [("use_fill", False),
         ],
        ),
       ],
      },
     ),
    ("mesh.rip_move",
     {"type": 'V', "value": 'PRESS', "alt": True},
     {"properties":
      [("MESH_OT_rip",
        [("use_fill", True),
         ],
        ),
       ],
      },
     ),
    ("mesh.rip_edge_move", {"type": 'D', "value": 'PRESS', "alt": True}, None),
    ("mesh.merge", {"type": 'X', "value": 'PRESS'}, None),
    ("transform.shrink_fatten", {"type": 'S', "value": 'PRESS', "alt": True}, None),
    ("mesh.edge_face_add", {"type": 'F', "value": 'PRESS'}, None),
    ("mesh.duplicate_move", {"type": 'D', "value": 'PRESS', "shift": True}, None),
    ("wm.call_menu",
     {"type": 'A', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_mesh_add'),
       ],
      },
     ),
    ("mesh.separate", {"type": 'P', "value": 'PRESS'}, None),
    ("mesh.split", {"type": 'Y', "value": 'PRESS'}, None),
    ("mesh.vert_connect_path", {"type": 'J', "value": 'PRESS'}, None),
    ("mesh.point_normals", {"type": 'L', "value": 'PRESS', "alt": True}, None),
    ("transform.vert_slide", {"type": 'V', "value": 'PRESS', "shift": True}, None),
    ("mesh.dupli_extrude_cursor",
     {"type": 'RIGHTMOUSE', "value": 'CLICK', "ctrl": True},
     {"properties":
      [("rotate_source", True),
       ],
      },
     ),
    ("mesh.dupli_extrude_cursor",
     {"type": 'RIGHTMOUSE', "value": 'CLICK', "shift": True, "ctrl": True},
     {"properties":
      [("rotate_source", False),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'X', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_delete'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'DEL', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_delete'),
       ],
      },
     ),
    ("mesh.dissolve_mode", {"type": 'X', "value": 'PRESS', "ctrl": True}, None),
    ("mesh.dissolve_mode", {"type": 'DEL', "value": 'PRESS', "ctrl": True}, None),
    ("mesh.knife_tool",
     {"type": 'K', "value": 'PRESS'},
     {"properties":
      [("use_occlude_geometry", True),
       ("only_selected", False),
       ],
      },
     ),
    ("object.vertex_parent_set", {"type": 'P', "value": 'PRESS', "ctrl": True}, None),
    ("wm.call_menu",
     {"type": 'RIGHTMOUSE', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_specials'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'F', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_faces'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'E', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_edges'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'V', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_edit_mesh_vertices'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'H', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_hook'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'U', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_uv_map'),
       ],
      },
     ),
    ("wm.call_menu",
     {"type": 'G', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_MT_vertex_group'),
       ],
      },
     ),
    ("object.vertex_group_remove_from", {"type": 'G', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ("wm.call_menu_pie",
     {"type": 'O', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_proportional_editing_falloff_pie'),
       ],
      },
     ),
    ("wm.context_toggle_enum",
     {"type": 'O', "value": 'PRESS'},
     {"properties":
      [("data_path", 'tool_settings.proportional_edit'),
       ("value_1", 'DISABLED'),
       ("value_2", 'ENABLED'),
       ],
      },
     ),
    ("wm.context_toggle_enum",
     {"type": 'O', "value": 'PRESS', "alt": True},
     {"properties":
      [("data_path", 'tool_settings.proportional_edit'),
       ("value_1", 'DISABLED'),
       ("value_2", 'CONNECTED'),
       ],
      },
     ),
    ("mesh.knife_tool",
     {"type": 'C', "value": 'PRESS'},
     {"properties":
      [("use_occlude_geometry", True),
       ("only_selected", False),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'F2', "value": 'PRESS'},
     {"properties":
      [("name", 'mesh.MyPie'),
       ],
      },
     ),
    ("mesh.select_linked", {"type": 'LEFTMOUSE', "value": 'DOUBLE_CLICK', "shift": True, "ctrl": True, "alt": True}, None),
    ("wm.tool_set_by_name",
     {"type": 'Q', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Box'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'W', "value": 'PRESS'},
     {"properties":
      [("name", 'Move'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'E', "value": 'PRESS'},
     {"properties":
      [("name", 'Rotate'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'R', "value": 'PRESS'},
     {"properties":
      [("name", 'Scale'),
       ],
      },
     ),
    ("view3d.select_circle", {"type": 'C', "value": 'PRESS', "alt": True}, None),
    ],
   },
  ),
 ("Object Non-modal",
  {"space_type": 'EMPTY', "region_type": 'WINDOW'},
  {"items":
   [("wm.call_menu_pie",
     {"type": 'TAB', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("name", 'view3d.snap_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'Z', "value": 'PRESS'},
     {"properties":
      [("name", 'pie.shade_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'view3d.pivot_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'TAB', "value": 'PRESS'},
     {"properties":
      [("name", 'pie.object_mode_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'SPACE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("name", 'view3d.manipulator_of'),
       ],
    "active":False,
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'NUMPAD_5', "value": 'PRESS'},
     {"properties":
      [("name", 'pie.view_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'TAB', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("name", 'view3d.snap_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'Z', "value": 'PRESS'},
     {"properties":
      [("name", 'pie.shade_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'view3d.pivot_of'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'TAB', "value": 'PRESS'},
     {"properties":
      [("name", 'pie.object_mode_of'),
       ],
      },
     ),
    ("view3d.object_mode_pie_or_toggle", {"type": 'TAB', "value": 'PRESS', "ctrl": True}, None),
    ("none", {"type": 'A', "value": 'PRESS'}, None),
    ],
   },
  ),
 ("3D View",
  {"space_type": 'VIEW_3D', "region_type": 'WINDOW'},
  {"items":
   [("view3d.cursor3d", {"type": 'RIGHTMOUSE', "value": 'PRESS', "shift": True}, None),
    ("transform.translate",
     {"type": 'EVT_TWEAK_R', "value": 'ANY', "shift": True},
     {"properties":
      [("cursor_transform", True),
       ("release_confirm", True),
       ],
      },
     ),
    ("view3d.localview", {"type": 'NUMPAD_SLASH', "value": 'PRESS'}, None),
    ("view3d.localview", {"type": 'SLASH', "value": 'PRESS'}, None),
    ("view3d.rotate", {"type": 'LEFTMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view3d.move", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view3d.zoom", {"type": 'RIGHTMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view3d.dolly", {"type": 'RIGHTMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view3d.view_selected",
     {"type": 'F', "value": 'PRESS'},
     {"properties":
      [("use_all_regions", True),
       ],
      },
     ),
    ("view3d.view_selected",
     {"type": 'NUMPAD_PERIOD', "value": 'PRESS'},
     {"properties":
      [("use_all_regions", False),
       ],
      },
     ),
    ("view3d.smoothview", {"type": 'TIMER1', "value": 'ANY', "any": True}, None),
    ("view3d.rotate", {"type": 'TRACKPADPAN', "value": 'ANY'}, None),
    ("view3d.rotate", {"type": 'MOUSEROTATE', "value": 'ANY'}, None),
    ("view3d.move", {"type": 'TRACKPADPAN', "value": 'ANY', "shift": True}, None),
    ("view3d.zoom", {"type": 'TRACKPADZOOM', "value": 'ANY'}, None),
    ("view3d.zoom", {"type": 'TRACKPADPAN', "value": 'ANY', "ctrl": True}, None),
    ("view3d.zoom",
     {"type": 'NUMPAD_PLUS', "value": 'PRESS'},
     {"properties":
      [("delta", 1),
       ],
      },
     ),
    ("view3d.zoom",
     {"type": 'NUMPAD_MINUS', "value": 'PRESS'},
     {"properties":
      [("delta", -1),
       ],
      },
     ),
    ("view3d.zoom",
     {"type": 'EQUAL', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("delta", 1),
       ],
      },
     ),
    ("view3d.zoom",
     {"type": 'MINUS', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("delta", -1),
       ],
      },
     ),
    ("view3d.zoom",
     {"type": 'WHEELINMOUSE', "value": 'PRESS'},
     {"properties":
      [("delta", 1),
       ],
      },
     ),
    ("view3d.zoom",
     {"type": 'WHEELOUTMOUSE', "value": 'PRESS'},
     {"properties":
      [("delta", -1),
       ],
      },
     ),
    ("view3d.dolly",
     {"type": 'NUMPAD_PLUS', "value": 'PRESS', "shift": True},
     {"properties":
      [("delta", 1),
       ],
      },
     ),
    ("view3d.dolly",
     {"type": 'NUMPAD_MINUS', "value": 'PRESS', "shift": True},
     {"properties":
      [("delta", -1),
       ],
      },
     ),
    ("view3d.dolly",
     {"type": 'EQUAL', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("delta", 1),
       ],
      },
     ),
    ("view3d.dolly",
     {"type": 'MINUS', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("delta", -1),
       ],
      },
     ),
    ("view3d.view_center_camera", {"type": 'HOME', "value": 'PRESS'}, None),
    ("view3d.view_center_lock", {"type": 'HOME', "value": 'PRESS'}, None),
    ("view3d.view_all",
     {"type": 'HOME', "value": 'PRESS'},
     {"properties":
      [("center", False),
       ],
      },
     ),
    ("view3d.view_all",
     {"type": 'HOME', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("use_all_regions", True),
       ("center", False),
       ],
      },
     ),
    ("view3d.view_all",
     {"type": 'C', "value": 'PRESS', "shift": True},
     {"properties":
      [("center", True),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'ACCENT_GRAVE', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_view_pie'),
       ],
      },
     ),
    ("view3d.navigate", {"type": 'ACCENT_GRAVE', "value": 'PRESS', "shift": True}, None),
    ("view3d.view_camera", {"type": 'NUMPAD_0', "value": 'PRESS'}, None),
    ("view3d.view_axis",
     {"type": 'NUMPAD_1', "value": 'PRESS'},
     {"properties":
      [("type", 'FRONT'),
       ],
      },
     ),
    ("view3d.view_orbit",
     {"type": 'NUMPAD_2', "value": 'PRESS'},
     {"properties":
      [("type", 'ORBITDOWN'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_3', "value": 'PRESS'},
     {"properties":
      [("type", 'RIGHT'),
       ],
      },
     ),
    ("view3d.view_orbit",
     {"type": 'NUMPAD_4', "value": 'PRESS'},
     {"properties":
      [("type", 'ORBITLEFT'),
       ],
      },
     ),
    ("view3d.view_persportho", {"type": 'NUMPAD_9', "value": 'PRESS'}, None),
    ("view3d.view_orbit",
     {"type": 'NUMPAD_6', "value": 'PRESS'},
     {"properties":
      [("type", 'ORBITRIGHT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_7', "value": 'PRESS'},
     {"properties":
      [("type", 'TOP'),
       ],
      },
     ),
    ("view3d.view_orbit",
     {"type": 'NUMPAD_8', "value": 'PRESS'},
     {"properties":
      [("type", 'ORBITUP'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_1', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'BACK'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_3', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'LEFT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_7', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'BOTTOM'),
       ],
      },
     ),
    ("view3d.view_pan",
     {"type": 'NUMPAD_2', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'PANDOWN'),
       ],
      },
     ),
    ("view3d.view_pan",
     {"type": 'NUMPAD_4', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'PANLEFT'),
       ],
      },
     ),
    ("view3d.view_pan",
     {"type": 'NUMPAD_6', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'PANRIGHT'),
       ],
      },
     ),
    ("view3d.view_pan",
     {"type": 'NUMPAD_8', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("type", 'PANUP'),
       ],
      },
     ),
    ("view3d.view_roll",
     {"type": 'NUMPAD_4', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'LEFT'),
       ],
      },
     ),
    ("view3d.view_roll",
     {"type": 'NUMPAD_6', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'RIGHT'),
       ],
      },
     ),
    ("view3d.view_orbit",
     {"type": 'NUMPAD_9', "value": 'PRESS'},
     {"properties":
      [("angle", 3.1415927),
       ("type", 'ORBITRIGHT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_1', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'FRONT'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_3', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'RIGHT'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_7', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'TOP'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_1', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("type", 'BACK'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_3', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("type", 'LEFT'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NUMPAD_7', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("type", 'BOTTOM'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'EVT_TWEAK_M', "value": 'NORTH', "alt": True},
     {"properties":
      [("type", 'TOP'),
       ("relative", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'EVT_TWEAK_M', "value": 'SOUTH', "alt": True},
     {"properties":
      [("type", 'BOTTOM'),
       ("relative", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'EVT_TWEAK_M', "value": 'EAST', "alt": True},
     {"properties":
      [("type", 'RIGHT'),
       ("relative", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'EVT_TWEAK_M', "value": 'WEST', "alt": True},
     {"properties":
      [("type", 'LEFT'),
       ("relative", True),
       ],
      },
     ),
    ("view3d.view_center_pick", {"type": 'MIDDLEMOUSE', "value": 'CLICK', "alt": True}, None),
    ("view3d.ndof_orbit_zoom", {"type": 'NDOF_MOTION', "value": 'ANY'}, None),
    ("view3d.ndof_orbit", {"type": 'NDOF_MOTION', "value": 'ANY', "ctrl": True}, None),
    ("view3d.ndof_pan", {"type": 'NDOF_MOTION', "value": 'ANY', "shift": True}, None),
    ("view3d.ndof_all", {"type": 'NDOF_MOTION', "value": 'ANY', "shift": True, "ctrl": True}, None),
    ("view3d.view_selected",
     {"type": 'NDOF_BUTTON_FIT', "value": 'PRESS'},
     {"properties":
      [("use_all_regions", False),
       ],
      },
     ),
    ("view3d.view_roll",
     {"type": 'NDOF_BUTTON_ROLL_CCW', "value": 'PRESS'},
     {"properties":
      [("type", 'LEFT'),
       ],
      },
     ),
    ("view3d.view_roll",
     {"type": 'NDOF_BUTTON_ROLL_CCW', "value": 'PRESS'},
     {"properties":
      [("type", 'RIGHT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_FRONT', "value": 'PRESS'},
     {"properties":
      [("type", 'FRONT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_BACK', "value": 'PRESS'},
     {"properties":
      [("type", 'BACK'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_LEFT', "value": 'PRESS'},
     {"properties":
      [("type", 'LEFT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_RIGHT', "value": 'PRESS'},
     {"properties":
      [("type", 'RIGHT'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_TOP', "value": 'PRESS'},
     {"properties":
      [("type", 'TOP'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_BOTTOM', "value": 'PRESS'},
     {"properties":
      [("type", 'BOTTOM'),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_FRONT', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'FRONT'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_RIGHT', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'RIGHT'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.view_axis",
     {"type": 'NDOF_BUTTON_TOP', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'TOP'),
       ("align_active", True),
       ],
      },
     ),
    ("view3d.select_or_deselect_all", {"type": 'LEFTMOUSE', "value": 'CLICK'}, None),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True},
     {"properties":
      [("toggle", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "ctrl": True},
     {"properties":
      [("center", True),
       ("object", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "alt": True},
     {"properties":
      [("enumerate", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "ctrl": True},
     {"properties":
      [("extend", True),
       ("toggle", True),
       ("center", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "ctrl": True, "alt": True},
     {"properties":
      [("center", True),
       ("enumerate", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "alt": True},
     {"properties":
      [("toggle", True),
       ("enumerate", True),
       ],
      },
     ),
    ("view3d.select",
     {"type": 'LEFTMOUSE', "value": 'CLICK', "shift": True, "ctrl": True, "alt": True},
     {"properties":
      [("toggle", True),
       ("center", True),
       ("enumerate", True),
       ],
      },
     ),
    ("view3d.select_box", {"type": 'B', "value": 'PRESS'}, None),
    ("view3d.select_lasso",
     {"type": 'EVT_TWEAK_R', "value": 'ANY', "ctrl": True},
     {"properties":
      [("mode", 'ADD'),
       ],
      },
     ),
    ("view3d.select_lasso",
     {"type": 'EVT_TWEAK_R', "value": 'ANY', "shift": True, "ctrl": True},
     {"properties":
      [("mode", 'SUB'),
       ],
      },
     ),
    ("view3d.select_circle", {"type": 'C', "value": 'PRESS'}, None),
    ("view3d.zoom_border", {"type": 'B', "value": 'PRESS', "shift": True}, None),
    ("view3d.render_border", {"type": 'B', "value": 'PRESS', "ctrl": True}, None),
    ("view3d.clear_render_border", {"type": 'B', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ("view3d.camera_to_view", {"type": 'NUMPAD_0', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ("view3d.object_as_camera", {"type": 'NUMPAD_0', "value": 'PRESS', "ctrl": True}, None),
    ("view3d.copybuffer", {"type": 'C', "value": 'PRESS', "ctrl": True}, None),
    ("view3d.pastebuffer", {"type": 'V', "value": 'PRESS', "ctrl": True}, None),
    ("wm.call_menu_pie",
     {"type": 'S', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'VIEW3D_MT_snap_pie'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_pivot_pie'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'COMMA', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_orientations_pie'),
       ],
      },
     ),
    ("transform.translate", {"type": 'G', "value": 'PRESS'}, None),
    ("transform.translate", {"type": 'EVT_TWEAK_L', "value": 'ANY'}, None),
    ("transform.rotate", {"type": 'R', "value": 'PRESS'}, None),
    ("transform.resize", {"type": 'S', "value": 'PRESS'}, None),
    ("transform.bend", {"type": 'W', "value": 'PRESS', "shift": True}, None),
    ("transform.tosphere", {"type": 'S', "value": 'PRESS', "shift": True, "alt": True}, None),
    ("transform.shear", {"type": 'S', "value": 'PRESS', "shift": True, "ctrl": True, "alt": True}, None),
    ("transform.mirror", {"type": 'M', "value": 'PRESS', "ctrl": True}, None),
    ("wm.context_toggle",
     {"type": 'TAB', "value": 'PRESS', "shift": True},
     {"properties":
      [("data_path", 'tool_settings.use_snap'),
       ],
      },
     ),
    ("wm.call_panel",
     {"type": 'TAB', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("name", 'VIEW3D_PT_snapping'),
       ("keep_open", False),
       ],
      },
     ),
    ("object.transform_axis_target", {"type": 'T', "value": 'PRESS', "shift": True}, None),
    ("transform.skin_resize", {"type": 'A', "value": 'PRESS', "ctrl": True}, None),
    ("wm.context_toggle",
     {"type": 'ACCENT_GRAVE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("data_path", 'space_data.show_gizmo_tool'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_pivot_pie'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'COMMA', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_orientations_pie'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'ACCENT_GRAVE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("data_path", 'space_data.show_gizmo_tool'),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'Z', "value": 'PRESS'},
     {"properties":
      [("name", 'VIEW3D_MT_shading_pie'),
       ],
      },
     ),
    ("view3d.toggle_shading",
     {"type": 'Z', "value": 'PRESS', "shift": True},
     {"properties":
      [("type", 'WIREFRAME'),
       ],
      },
     ),
    ("view3d.toggle_xray", {"type": 'Z', "value": 'PRESS', "alt": True}, None),
    ("wm.context_toggle",
     {"type": 'Z', "value": 'PRESS', "shift": True, "alt": True},
     {"properties":
      [("data_path", 'space_data.overlay.show_overlays'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'W', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Box'),
       ("cycle", True),
       ],
      },
     ),
    ("view3d.edit_mesh_extrude_move_normal", {"type": 'E', "value": 'PRESS', "shift": True}, None),
    ("object.editmode_toggle", {"type": 'FOUR', "value": 'PRESS'}, None),
    ("view3d.toggle_shading",
     {"type": 'F3', "value": 'PRESS'},
     {"properties":
      [("type", 'WIREFRAME'),
       ],
      },
     ),
    ("view3d.toggle_shading",
     {"type": 'F4', "value": 'PRESS'},
     {"properties":
      [("type", 'SOLID'),
       ],
      },
     ),
    ("view3d.toggle_shading",
     {"type": 'F5', "value": 'PRESS'},
     {"properties":
      [("type", 'MATERIAL'),
       ],
      },
     ),
    ("view3d.toggle_shading",
     {"type": 'F6', "value": 'PRESS'},
     {"properties":
      [("type", 'RENDERED'),
       ],
      },
     ),
    ],
   },
  ),
 ("View2D",
  {"space_type": 'EMPTY', "region_type": 'WINDOW'},
  {"items":
   [("view2d.scroller_activate", {"type": 'LEFTMOUSE', "value": 'PRESS'}, None),
    ("view2d.scroller_activate", {"type": 'MIDDLEMOUSE', "value": 'PRESS'}, None),
    ("view2d.pan", {"type": 'MIDDLEMOUSE', "value": 'PRESS'}, None),
    ("view2d.pan", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view2d.pan", {"type": 'TRACKPADPAN', "value": 'ANY'}, None),
    ("view2d.scroll_right", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS', "ctrl": True}, None),
    ("view2d.scroll_left", {"type": 'WHEELUPMOUSE', "value": 'PRESS', "ctrl": True}, None),
    ("view2d.scroll_down", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS', "shift": True}, None),
    ("view2d.scroll_up", {"type": 'WHEELUPMOUSE', "value": 'PRESS', "shift": True}, None),
    ("view2d.ndof", {"type": 'NDOF_MOTION', "value": 'ANY'}, None),
    ("view2d.zoom_out", {"type": 'WHEELOUTMOUSE', "value": 'PRESS'}, None),
    ("view2d.zoom_in", {"type": 'WHEELINMOUSE', "value": 'PRESS'}, None),
    ("view2d.zoom_out", {"type": 'NUMPAD_MINUS', "value": 'PRESS'}, None),
    ("view2d.zoom_in", {"type": 'NUMPAD_PLUS', "value": 'PRESS'}, None),
    ("view2d.smoothview", {"type": 'TIMER1', "value": 'ANY', "any": True}, None),
    ("view2d.scroll_down", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS'}, None),
    ("view2d.scroll_up", {"type": 'WHEELUPMOUSE', "value": 'PRESS'}, None),
    ("view2d.scroll_right", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS'}, None),
    ("view2d.scroll_left", {"type": 'WHEELUPMOUSE', "value": 'PRESS'}, None),
    ("view2d.zoom", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "ctrl": True}, None),
    ("view2d.zoom", {"type": 'RIGHTMOUSE', "value": 'PRESS', "alt": True}, None),
    ("view2d.zoom_border", {"type": 'B', "value": 'PRESS', "shift": True}, None),
    ],
   },
  ),
 ("Transform Modal Map",
  {"space_type": 'EMPTY', "region_type": 'WINDOW', "modal": True},
  {"items":
   [("CONFIRM", {"type": 'LEFTMOUSE', "value": 'PRESS', "any": True}, None),
    ("CONFIRM", {"type": 'RET', "value": 'PRESS', "any": True}, None),
    ("CONFIRM", {"type": 'NUMPAD_ENTER', "value": 'PRESS', "any": True}, None),
    ("CANCEL", {"type": 'RIGHTMOUSE', "value": 'PRESS', "any": True}, None),
    ("CANCEL", {"type": 'ESC', "value": 'PRESS', "any": True}, None),
    ("AXIS_X", {"type": 'X', "value": 'PRESS'}, None),
    ("AXIS_Y", {"type": 'Y', "value": 'PRESS'}, None),
    ("AXIS_Z", {"type": 'Z', "value": 'PRESS'}, None),
    ("PLANE_X", {"type": 'X', "value": 'PRESS', "shift": True}, None),
    ("PLANE_Y", {"type": 'Y', "value": 'PRESS', "shift": True}, None),
    ("PLANE_Z", {"type": 'Z', "value": 'PRESS', "shift": True}, None),
    ("CONS_OFF", {"type": 'C', "value": 'PRESS'}, None),
    ("TRANSLATE", {"type": 'G', "value": 'PRESS'}, None),
    ("ROTATE", {"type": 'R', "value": 'PRESS'}, None),
    ("RESIZE", {"type": 'S', "value": 'PRESS'}, None),
    ("SNAP_TOGGLE", {"type": 'TAB', "value": 'PRESS', "shift": True}, None),
    ("SNAP_INV_ON", {"type": 'LEFT_CTRL', "value": 'PRESS', "any": True}, None),
    ("SNAP_INV_OFF", {"type": 'LEFT_CTRL', "value": 'RELEASE', "any": True}, None),
    ("SNAP_INV_ON", {"type": 'RIGHT_CTRL', "value": 'PRESS', "any": True}, None),
    ("SNAP_INV_OFF", {"type": 'RIGHT_CTRL', "value": 'RELEASE', "any": True}, None),
    ("ADD_SNAP", {"type": 'A', "value": 'PRESS'}, None),
    ("REMOVE_SNAP", {"type": 'A', "value": 'PRESS', "alt": True}, None),
    ("PROPORTIONAL_SIZE_UP", {"type": 'UP_ARROW', "value": 'PRESS'}, None),
    ("PROPORTIONAL_SIZE_DOWN", {"type": 'DOWN_ARROW', "value": 'PRESS'}, None),
    ("PROPORTIONAL_SIZE_UP", {"type": 'PAGE_UP', "value": 'PRESS', "shift": True}, None),
    ("PROPORTIONAL_SIZE_DOWN", {"type": 'PAGE_DOWN', "value": 'PRESS', "shift": True}, None),
    ("PROPORTIONAL_SIZE_UP", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS'}, None),
    ("PROPORTIONAL_SIZE_DOWN", {"type": 'WHEELUPMOUSE', "value": 'PRESS'}, None),
    ("PROPORTIONAL_SIZE_UP", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS', "shift": True}, None),
    ("PROPORTIONAL_SIZE_DOWN", {"type": 'WHEELUPMOUSE', "value": 'PRESS', "shift": True}, None),
    ("PROPORTIONAL_SIZE", {"type": 'TRACKPADPAN', "value": 'ANY'}, None),
    ("EDGESLIDE_EDGE_NEXT", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS', "alt": True}, None),
    ("EDGESLIDE_PREV_NEXT", {"type": 'WHEELUPMOUSE', "value": 'PRESS', "alt": True}, None),
    ("AUTOIK_CHAIN_LEN_UP", {"type": 'PAGE_UP', "value": 'PRESS', "shift": True}, None),
    ("AUTOIK_CHAIN_LEN_DOWN", {"type": 'PAGE_DOWN', "value": 'PRESS', "shift": True}, None),
    ("AUTOIK_CHAIN_LEN_UP", {"type": 'WHEELDOWNMOUSE', "value": 'PRESS', "shift": True}, None),
    ("AUTOIK_CHAIN_LEN_DOWN", {"type": 'WHEELUPMOUSE', "value": 'PRESS', "shift": True}, None),
    ("INSERTOFS_TOGGLE_DIR", {"type": 'T', "value": 'PRESS'}, None),
    ],
   },
  ),
 ("Image",
  {"space_type": 'IMAGE_EDITOR', "region_type": 'WINDOW'},
  {"items":
   [("image.view_all", {"type": 'HOME', "value": 'PRESS'}, None),
    ("image.view_all",
     {"type": 'HOME', "value": 'PRESS', "shift": True},
     {"properties":
      [("fit_view", True),
       ],
      },
     ),
    ("image.view_selected", {"type": 'NUMPAD_PERIOD', "value": 'PRESS'}, None),
    ("image.view_pan", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "alt": True}, None),
    ("image.view_pan",
     {"type": 'MIDDLEMOUSE', "value": 'PRESS', "shift": True},
     {    "active":False,
      },
     ),
    ("image.view_pan", {"type": 'TRACKPADPAN', "value": 'ANY'}, None),
    ("image.view_all", {"type": 'NDOF_BUTTON_FIT', "value": 'PRESS'}, None),
    ("image.view_ndof", {"type": 'NDOF_MOTION', "value": 'ANY'}, None),
    ("image.view_zoom_in", {"type": 'WHEELINMOUSE', "value": 'PRESS'}, None),
    ("image.view_zoom_out", {"type": 'WHEELOUTMOUSE', "value": 'PRESS'}, None),
    ("image.view_zoom_in", {"type": 'NUMPAD_PLUS', "value": 'PRESS'}, None),
    ("image.view_zoom_out", {"type": 'NUMPAD_MINUS', "value": 'PRESS'}, None),
    ("image.view_zoom", {"type": 'RIGHTMOUSE', "value": 'PRESS', "alt": True}, None),
    ("image.view_zoom", {"type": 'TRACKPADPAN', "value": 'ANY', "ctrl": True}, None),
    ("image.view_zoom_border", {"type": 'B', "value": 'PRESS', "shift": True}, None),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 8.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 4.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 2.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 8.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 4.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 2.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_1', "value": 'PRESS'},
     {"properties":
      [("ratio", 1.0),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.5),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.25),
       ],
      },
     ),
    ("image.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.125),
       ],
      },
     ),
    ("image.change_frame", {"type": 'LEFTMOUSE', "value": 'PRESS'}, None),
    ("image.sample", {"type": 'RIGHTMOUSE', "value": 'PRESS'}, None),
    ("image.curves_point_set",
     {"type": 'RIGHTMOUSE', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("point", 'BLACK_POINT'),
       ],
      },
     ),
    ("image.curves_point_set",
     {"type": 'RIGHTMOUSE', "value": 'PRESS', "shift": True},
     {"properties":
      [("point", 'WHITE_POINT'),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'ONE', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 0),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'TWO', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 1),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'THREE', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 2),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'FOUR', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 3),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'FIVE', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 4),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'SIX', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 5),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'SEVEN', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 6),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'EIGHT', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 7),
       ],
      },
     ),
    ("wm.context_set_int",
     {"type": 'NINE', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.image.render_slots.active_index'),
       ("value", 8),
       ],
      },
     ),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'IMAGE_MT_pivot_pie'),
       ],
      },
     ),
    ("image.render_border", {"type": 'B', "value": 'PRESS', "ctrl": True}, None),
    ("image.clear_render_border", {"type": 'B', "value": 'PRESS', "ctrl": True, "alt": True}, None),
    ],
   },
  ),
 ("Clip Editor",
  {"space_type": 'CLIP_EDITOR', "region_type": 'WINDOW'},
  {"items":
   [("clip.view_pan", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "alt": True}, None),
    ("clip.view_pan", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "shift": True}, None),
    ("clip.view_pan", {"type": 'TRACKPADPAN', "value": 'ANY'}, None),
    ("clip.view_zoom", {"type": 'MIDDLEMOUSE', "value": 'PRESS', "ctrl": True}, None),
    ("clip.view_zoom", {"type": 'TRACKPADZOOM', "value": 'ANY'}, None),
    ("clip.view_zoom", {"type": 'TRACKPADPAN', "value": 'ANY', "ctrl": True}, None),
    ("clip.view_zoom_in", {"type": 'WHEELINMOUSE', "value": 'PRESS'}, None),
    ("clip.view_zoom_out", {"type": 'WHEELOUTMOUSE', "value": 'PRESS'}, None),
    ("clip.view_zoom_in", {"type": 'NUMPAD_PLUS', "value": 'PRESS'}, None),
    ("clip.view_zoom_out", {"type": 'NUMPAD_MINUS', "value": 'PRESS'}, None),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 8.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 4.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("ratio", 2.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 8.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 4.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS', "shift": True},
     {"properties":
      [("ratio", 2.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_1', "value": 'PRESS'},
     {"properties":
      [("ratio", 1.0),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_2', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.5),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_4', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.25),
       ],
      },
     ),
    ("clip.view_zoom_ratio",
     {"type": 'NUMPAD_8', "value": 'PRESS'},
     {"properties":
      [("ratio", 0.125),
       ],
      },
     ),
    ("clip.view_all", {"type": 'HOME', "value": 'PRESS'}, None),
    ("clip.view_all",
     {"type": 'F', "value": 'PRESS'},
     {"properties":
      [("fit_view", True),
       ],
      },
     ),
    ("clip.view_selected", {"type": 'NUMPAD_PERIOD', "value": 'PRESS'}, None),
    ("clip.view_all", {"type": 'NDOF_BUTTON_FIT', "value": 'PRESS'}, None),
    ("clip.view_ndof", {"type": 'NDOF_MOTION', "value": 'ANY'}, None),
    ("clip.frame_jump",
     {"type": 'LEFT_ARROW', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("position", 'PATHSTART'),
       ],
      },
     ),
    ("clip.frame_jump",
     {"type": 'RIGHT_ARROW', "value": 'PRESS', "shift": True, "ctrl": True},
     {"properties":
      [("position", 'PATHEND'),
       ],
      },
     ),
    ("clip.frame_jump",
     {"type": 'LEFT_ARROW', "value": 'PRESS', "shift": True, "alt": True},
     {"properties":
      [("position", 'FAILEDPREV'),
       ],
      },
     ),
    ("clip.frame_jump",
     {"type": 'RIGHT_ARROW', "value": 'PRESS', "shift": True, "alt": True},
     {"properties":
      [("position", 'PATHSTART'),
       ],
      },
     ),
    ("clip.change_frame", {"type": 'LEFTMOUSE', "value": 'PRESS'}, None),
    ("clip.select",
     {"type": 'LEFTMOUSE', "value": 'PRESS'},
     {"properties":
      [("extend", False),
       ],
      },
     ),
    ("clip.select",
     {"type": 'LEFTMOUSE', "value": 'PRESS', "shift": True},
     {"properties":
      [("extend", True),
       ],
      },
     ),
    ("clip.select_all",
     {"type": 'A', "value": 'PRESS'},
     {"properties":
      [("action", 'SELECT'),
       ],
      },
     ),
    ("clip.select_all",
     {"type": 'A', "value": 'PRESS', "alt": True},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("clip.select_all",
     {"type": 'I', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("action", 'INVERT'),
       ],
      },
     ),
    ("clip.select_all",
     {"type": 'A', "value": 'DOUBLE_CLICK'},
     {"properties":
      [("action", 'DESELECT'),
       ],
      },
     ),
    ("clip.select_box", {"type": 'B', "value": 'PRESS'}, None),
    ("clip.select_circle", {"type": 'C', "value": 'PRESS'}, None),
    ("wm.call_menu",
     {"type": 'G', "value": 'PRESS', "shift": True},
     {"properties":
      [("name", 'CLIP_MT_select_grouped'),
       ],
      },
     ),
    ("clip.select_lasso",
     {"type": 'EVT_TWEAK_R', "value": 'ANY', "ctrl": True, "alt": True},
     {"properties":
      [("deselect", False),
       ],
      },
     ),
    ("clip.select_lasso",
     {"type": 'EVT_TWEAK_R', "value": 'ANY', "shift": True, "ctrl": True, "alt": True},
     {"properties":
      [("deselect", True),
       ],
      },
     ),
    ("clip.add_marker_slide", {"type": 'LEFTMOUSE', "value": 'PRESS', "ctrl": True}, None),
    ("clip.delete_marker", {"type": 'X', "value": 'PRESS', "shift": True}, None),
    ("clip.delete_marker", {"type": 'DEL', "value": 'PRESS', "shift": True}, None),
    ("clip.slide_marker", {"type": 'LEFTMOUSE', "value": 'PRESS'}, None),
    ("clip.disable_markers",
     {"type": 'D', "value": 'PRESS', "shift": True},
     {"properties":
      [("action", 'TOGGLE'),
       ],
      },
     ),
    ("clip.delete_track", {"type": 'X', "value": 'PRESS'}, None),
    ("clip.delete_track", {"type": 'DEL', "value": 'PRESS'}, None),
    ("clip.lock_tracks",
     {"type": 'L', "value": 'PRESS', "ctrl": True},
     {"properties":
      [("action", 'LOCK'),
       ],
      },
     ),
    ("clip.lock_tracks",
     {"type": 'L', "value": 'PRESS', "alt": True},
     {"properties":
      [("action", 'UNLOCK'),
       ],
      },
     ),
    ("clip.hide_tracks",
     {"type": 'H', "value": 'PRESS'},
     {"properties":
      [("unselected", False),
       ],
      },
     ),
    ("clip.hide_tracks",
     {"type": 'H', "value": 'PRESS', "shift": True},
     {"properties":
      [("unselected", True),
       ],
      },
     ),
    ("clip.hide_tracks_clear", {"type": 'H', "value": 'PRESS', "alt": True}, None),
    ("clip.slide_plane_marker", {"type": 'RIGHTMOUSE', "value": 'PRESS'}, None),
    ("clip.keyframe_insert", {"type": 'I', "value": 'PRESS'}, None),
    ("clip.keyframe_delete", {"type": 'I', "value": 'PRESS', "alt": True}, None),
    ("clip.join_tracks", {"type": 'J', "value": 'PRESS', "ctrl": True}, None),
    ("wm.call_menu",
     {"type": 'RIGHTMOUSE', "value": 'PRESS'},
     {"properties":
      [("name", 'CLIP_MT_tracking_specials'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'L', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.lock_selection'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'D', "value": 'PRESS', "alt": True},
     {"properties":
      [("data_path", 'space_data.show_disabled'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'S', "value": 'PRESS', "alt": True},
     {"properties":
      [("data_path", 'space_data.show_marker_search'),
       ],
      },
     ),
    ("wm.context_toggle",
     {"type": 'M', "value": 'PRESS'},
     {"properties":
      [("data_path", 'space_data.use_mute_footage'),
       ],
      },
     ),
    ("transform.translate", {"type": 'G', "value": 'PRESS'}, None),
    ("transform.translate", {"type": 'EVT_TWEAK_L', "value": 'ANY'}, None),
    ("transform.resize", {"type": 'S', "value": 'PRESS'}, None),
    ("transform.rotate", {"type": 'R', "value": 'PRESS'}, None),
    ("clip.clear_track_path",
     {"type": 'T', "value": 'PRESS', "alt": True},
     {"properties":
      [("action", 'REMAINED'),
       ("clear_active", False),
       ],
      },
     ),
    ("clip.clear_track_path",
     {"type": 'T', "value": 'PRESS', "shift": True},
     {"properties":
      [("action", 'UPTO'),
       ("clear_active", False),
       ],
      },
     ),
    ("clip.clear_track_path",
     {"type": 'T', "value": 'PRESS', "shift": True, "alt": True},
     {"properties":
      [("action", 'ALL'),
       ("clear_active", False),
       ],
      },
     ),
    ("clip.cursor_set", {"type": 'RIGHTMOUSE', "value": 'PRESS', "shift": True}, None),
    ("wm.call_menu_pie",
     {"type": 'PERIOD', "value": 'PRESS'},
     {"properties":
      [("name", 'CLIP_MT_pivot_pie'),
       ],
      },
     ),
    ("clip.copy_tracks", {"type": 'C', "value": 'PRESS', "ctrl": True}, None),
    ("clip.paste_tracks", {"type": 'V', "value": 'PRESS', "ctrl": True}, None),
    ],
   },
  ),
 ("Toolbar Popup <temp>",
  {"space_type": 'EMPTY', "region_type": 'TEMPORARY'},
  {"items":
   [("wm.tool_set_by_name",
     {"type": 'Q', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Box'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'E', "value": 'PRESS'},
     {"properties":
      [("name", 'Rotate'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'R', "value": 'PRESS'},
     {"properties":
      [("name", 'Scale'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'S', "value": 'PRESS'},
     {"properties":
      [("name", 'Scale Cage'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'ONE', "value": 'PRESS'},
     {"properties":
      [("name", 'Select'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_1', "value": 'PRESS'},
     {"properties":
      [("name", 'Select'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'TWO', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Circle'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_2', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Circle'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'THREE', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Lasso'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_3', "value": 'PRESS'},
     {"properties":
      [("name", 'Select Lasso'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'FOUR', "value": 'PRESS'},
     {"properties":
      [("name", 'Transform'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_4', "value": 'PRESS'},
     {"properties":
      [("name", 'Transform'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'FIVE', "value": 'PRESS'},
     {"properties":
      [("name", 'Move'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_5', "value": 'PRESS'},
     {"properties":
      [("name", 'Move'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'SIX', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_6', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'SEVEN', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Line'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_7', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Line'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'EIGHT', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Polygon'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_8', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Polygon'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NINE', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Eraser'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_9', "value": 'PRESS'},
     {"properties":
      [("name", 'Annotate Eraser'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'ZERO', "value": 'PRESS'},
     {"properties":
      [("name", 'Measure'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'NUMPAD_0', "value": 'PRESS'},
     {"properties":
      [("name", 'Measure'),
       ],
      },
     ),
    ("wm.tool_set_by_name",
     {"type": 'SPACE', "value": 'PRESS'},
     {"properties":
      [("name", 'Cursor'),
       ],
      },
     ),
    ("ui.button_execute",
     {"type": 'SPACE', "value": 'RELEASE', "any": True},
     {"properties":
      [("skip_depressed", True),
       ],
      },
     ),
    ("wm.tool_set_by_name", {"type": 'SPACE', "value": 'RELEASE', "any": True}, None),
    ],
   },
  ),
 ]


if __name__ == "__main__":
    import os
    from bl_keymap_utils.io import keyconfig_import_from_data
    keyconfig_import_from_data(os.path.splitext(os.path.basename(__file__))[0], keyconfig_data)
